#define _CRT_SECURE_NO_WARNINGS
#include "testlib.h"
#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
using namespace std;
int vec_y[] = { 1, 1, -1, -1 };
int vec_x[] = { 1, -1, 1, -1 };
bool correct(const int& min_n, const int& n, const int& max_n)
{
	return (min_n <= n) && (n <= max_n);
}
int main(int argc, char **argv)
{
	//argc = 5;
	//argv[1] = "10"; argv[2] = "10"; argv[3] = "3"; argv[4] = "10";
	registerGen(argc, argv, 1);
	int h = atoi(argv[1]);
	int w = atoi(argv[2]);
	int k = atoi(argv[3]);
	//int l = atoi(argv[4]);
	//int r = atoi(argv[5]);
	int p = atoi(argv[4]);
	pair<int, int> wh;
	wh.first = rnd.next(1, h);
	wh.second = rnd.next(1, w);
	while ((wh.first ^ wh.second) & 1)
	{
		wh.first = rnd.next(1, h);
		wh.second = rnd.next(1, w);
	}
	set<pair<int, int>> s;
	s.insert(wh);
	for (int i = 0; i < k; ++i)
	{
		bool fale = true;
		vector<pair<int, int>> q(4);
		vector<pair<int, int>> sdv(3);
		while (fale)
		{
			int pleft = p + 1 - ((int)(s.size()));
			int new_l = rnd.next(1, 2 * pleft / (k + 1 - i));
			vector<int> l(3);
			l[0] = rnd.next(0, new_l * 2 / 3);
			l[1] = rnd.next(0, new_l - l[0]);
			l[2] = new_l - l[0] - l[1];
			shuffle(l.begin(), l.end());
			int dir1 = rnd.next(0, 3);
			int dir2 = (dir1 + 1 + 2 * rnd.next(0, 1)) % 4;
			int dir3 = (dir2 + 1 + 2 * rnd.next(0, 1)) % 4;
			sdv[0].first = vec_y[dir1];
			sdv[0].second = vec_x[dir1];
			sdv[1].first = vec_y[dir2];
			sdv[1].second = vec_x[dir2];
			sdv[2].first = vec_y[dir3];
			sdv[2].second = vec_x[dir3];
			if ((l[1] != 0) || (l[0] == 0) || (l[2] == 0))
			{
				q[0] = wh;
				q[1] = pair<int, int>(q[0].first + vec_y[dir1] * l[0] * 2, q[0].second + vec_x[dir1] * l[0] * 2);
				q[2] = pair<int, int>(q[1].first + vec_y[dir2] * l[1] * 2, q[1].second + vec_x[dir2] * l[1] * 2);
				q[3] = pair<int, int>(q[2].first + vec_y[dir3] * l[2] * 2, q[2].second + vec_x[dir3] * l[2] * 2);
				if (correct(1, q[0].first, h) && correct(1, q[0].second, w) &&
					correct(1, q[1].first, h) && correct(1, q[1].second, w) &&
					correct(1, q[2].first, h) && correct(1, q[2].second, w) &&
					correct(1, q[3].first, h) && correct(1, q[3].second, w))
					fale = false;
			}
		}
		for (int t = 0; t < 3; ++t)
		{
			pair<int, int> keks = q[t];
			pair<int, int> dv = sdv[t];
			while (keks != q[t + 1])
			{
				s.insert(pair<int, int>(keks.first + dv.first, keks.second + dv.second));
				keks = pair<int, int>(keks.first + 2 * dv.first, keks.second + 2 * dv.second);
			}
		}
	}
	while (s.size() < p + 1)
	{
		int x = 0, y = 1;
		while ((x ^ y) & 1)
		{
			y = rnd.next(1, h);
			x = rnd.next(1, w);
		}
		s.insert(pair<int, int>(y, x));
	}
	cout << h << ' ' << w << ' ' << p << '\n';
	cout << wh.first << ' ' << wh.second << '\n';
	s.erase(wh);
	vector<pair<int, int>> vans;
	for (auto it = s.begin(); it != s.end(); ++it)
		vans.push_back(*it);
	shuffle(vans.begin(), vans.end());
	for (int i = 0; i < vans.size(); ++i)
		cout << vans[i].first << ' ' << vans[i].second << '\n';
	return 0;
}