#define _CRT_SECTURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
bool correct(const int& min_n, const int& n, const int& max_n)
{
	return (min_n <= n) && (n <= max_n);
}
const pair<int, int> vc[] = { { 1, 1 }, { -1, 1 }, { -1, -1 }, { 1, -1 } };
int answer(const pair<int, int>& p, const set<pair<int, int>>& s, const int& dir,
	const int& min_h, const int& max_h, const int& min_w, const int& max_w,
	const int& rotates, const bool& once)
{
	int ans = 0;
	pair<int, int> pp(p.first + 2 * vc[dir].first, p.second + 2 * vc[dir].second);
	if (correct(min_h, pp.first, max_h) && correct(min_w, pp.second, max_w))
	{
		if ((s.find(pp) == s.end()) &&
			(s.find(pair<int, int>(p.first + vc[dir].first, p.second + vc[dir].second)) != s.end()))
			ans = max(ans, answer(pp, s, dir, min_h, max_h, min_w, max_w, rotates, true) + 1);
	}
	if (once && rotates)
	{
		ans = max(ans, answer(p, s, (dir + 1) % 4, min_h, max_h, min_w, max_w, rotates - 1, false));
		ans = max(ans, answer(p, s, (dir + 3) % 4, min_h, max_h, min_w, max_w, rotates - 1, false));
	}
	return ans;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int h, w, n;
	cin >> h >> w >> n;
	pair<int, int> p;
	cin >> p.first >> p.second;
	set<pair<int, int>> s;
	for (int i = 0; i < n; ++i)
	{
		pair<int, int> r;
		cin >> r.first >> r.second;
		s.insert(r);
	}
	int ans = 0;
	for (int i = 0; i < 4; ++i)
		ans = max(ans, answer(p, s, i, 1, h, 1, w, 2, false));
	cout << ans << '\n';
	return 0;
}