#define _CRT_SECTURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
using namespace std;
const int vec_dif[] = { 1, 0, -1, 0 };
const int vec_sum[] = { 0, 1, 0, -1 };
const int vec = 4;
bool correct(const int& min_n, const int& n, const int& max_n)
{
	return (min_n <= n) && (n <= max_n);
}
bool correct_dif_sum(const int& dif, const int& sum, const int& h, const int& w)
{
	int y = sum + dif, x = sum - dif;
	return correct(1, y, h) && correct(1, x, w);
}
int main()
{
	int h, w, n;
	cin >> h >> w >> n;
	pair<int, int> p;
	cin >> p.first >> p.second;
	unordered_map<int, unordered_set<int>> difs;
	for (int i = 0; i < n; ++i)
	{
		pair<int, int> q;
		cin >> q.first >> q.second;
		int qsum = (q.first + q.second) / 2, qdif = (q.first - q.second) / 2;
		difs[qdif].insert(qsum);
	}
	unordered_map<int, set<int>> dif_applicants, sum_applicants;
	for (auto it = difs.begin(); it != difs.end(); ++it)
	{
		int dif = it->first;
		for (auto jt = it->second.begin(); jt != it->second.end(); ++jt)
		{
			int sum = *jt;
			for (int v = 0; v < vec; ++v)
			{
				int app_dif = dif + vec_dif[v];
				int app_sum = sum + vec_sum[v];
				if (correct_dif_sum(app_dif, app_sum, h, w))
				{
					dif_applicants[app_dif].insert(app_sum);
					sum_applicants[app_sum].insert(app_dif);
				}
			}
		}
	}

	vector<vector<unordered_map<int, unordered_map<int, int>>>> answer(1,
		vector<unordered_map<int, unordered_map<int, int>>>(4));

	for (int I = 0; I < 1; ++I)
	{
		for (auto it = dif_applicants.begin(); it != dif_applicants.end(); ++it)
		{
			int v = 3;
			int dif = it->first;
			for (auto jt = it->second.begin(); jt != it->second.end(); ++jt)
			{
				int sum = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = dif_applicants.begin(); it != dif_applicants.end(); ++it)
		{
			int v = 1;
			int dif = it->first;
			for (auto jt = it->second.rbegin(); jt != it->second.rend(); ++jt)
			{
				int sum = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = sum_applicants.begin(); it != sum_applicants.end(); ++it)
		{
			int v = 0;
			int sum = it->first;
			for (auto jt = it->second.rbegin(); jt != it->second.rend(); ++jt)
			{
				int dif = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = sum_applicants.begin(); it != sum_applicants.end(); ++it)
		{
			int v = 2;
			int sum = it->first;
			for (auto jt = it->second.begin(); jt != it->second.end(); ++jt)
			{
				int dif = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
	}
	int ans = 0;
	for (int I = 0; I < 1; ++I)
	for (int v = 0; v < 4; ++v)
		ans = max(ans, answer[I][v][(p.first - p.second) / 2][(p.first + p.second) / 2]);
	cout << ans << '\n';
	return 0;
}