#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <unordered_set>
#include <algorithm>
using namespace std;
const int vec_dif[] = { 1, 0, -1, 0 };
const int vec_sum[] = { 0, 1, 0, -1 };
const int vec = 4;
inline bool correct(const int& min_n, const int& n, const int& max_n)
{
	return (min_n <= n) && (n <= max_n);
}
inline bool correct_dif_sum(const int& dif, const int& sum, const int& h, const int& w)
{
	int y = sum + dif, x = sum - dif;
	return correct(1, y, h) && correct(1, x, w);
}
const int C = 1000000, D = 2 * C + 1;
int main()
{/*
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	freopen("c.in", "r", stdin);
	freopen("c.out", "w", stdout);*/
	int h, w, n;
	//cin >> h >> w >> n;
	scanf("%d%d%d", &h, &w, &n);
	cerr << h << ' ' << w << ' ' << n << '\n';
	pair<int, int> p;
	scanf("%d%d", &p.first, &p.second);
	vector<pair<int, int>> q(n);
	for (int i = 0; i < n; ++i)
		 scanf("%d%d", &q[i].first, &q[i].second);
	cerr << "input\n";
	unordered_map<int, unordered_set<int>> difs;
	for (int i = 0; i < n; ++i)
	{
		int qsum = (q[i].first + q[i].second) / 2, qdif = (q[i].first - q[i].second) / 2;
		difs[qdif].insert(qsum);
	}
	cerr << "difs" << '\n';
	vector<unordered_set<int>> dif_applicants(D), sum_applicants(D);
	for (auto it = difs.begin(); it != difs.end(); ++it)
	{
		int dif = it->first;
		for (auto jt = it->second.begin(); jt != it->second.end(); ++jt)
		{
			int sum = *jt;
			for (int v = 0; v < vec; ++v)
			{
				int app_dif = dif + vec_dif[v];
				int app_sum = sum + vec_sum[v];
				if (correct_dif_sum(app_dif, app_sum, h, w))
				{
					dif_applicants[app_dif + C].insert(app_sum);
					sum_applicants[app_sum].insert(app_dif);
				}
			}
		}
	}
	cerr << "applicants\n";
	vector<vector<unordered_map<int, unordered_map<int, int>>>> answer(3,
		vector<unordered_map<int, unordered_map<int, int>>>(4));
	return 0;
	for (int I = 0; I < 3; ++I)
	{
		for (auto it = dif_applicants.begin(); it != dif_applicants.end(); ++it)
		{
			int v = 3;
			//int dif = it->first - C;
			int dif = (it - dif_applicants.begin()) - C;
			for (auto jt = it->begin(); jt != it->end(); ++jt)
			{
				int sum = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = dif_applicants.begin(); it != dif_applicants.end(); ++it)
		{
			int v = 1;
			int dif = (it - dif_applicants.begin()) - C;
			for (auto jt = it->rbegin(); jt != it->rend(); ++jt)
			{
				int sum = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = sum_applicants.begin(); it != sum_applicants.end(); ++it)
		{
			int v = 0;
			int sum = (it - sum_applicants.begin());
			for (auto jt = it->rbegin(); jt != it->rend(); ++jt)
			{
				int dif = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
		for (auto it = sum_applicants.begin(); it != sum_applicants.end(); ++it)
		{
			int v = 2;
			int sum = (it - sum_applicants.begin());
			for (auto jt = it->begin(); jt != it->end(); ++jt)
			{
				int dif = *jt;

				int filled_dif = dif + vec_dif[v];
				int filled_sum = sum + vec_sum[v];

				int free_dif = filled_dif + vec_dif[v];
				int free_sum = filled_sum + vec_sum[v];

				if (correct_dif_sum(free_dif, free_sum, h, w) &&
					(difs[filled_dif].find(filled_sum) != difs[filled_dif].end()) &&
					(difs[free_dif].find(free_sum) == difs[free_dif].end()))
				{
					answer[I][v][dif][sum] = 1 + max(answer[I][v][free_dif][free_sum], (I ? max(
						answer[I - 1][(v + 1) % 4][free_dif][free_sum],
						answer[I - 1][(v + 3) % 4][free_dif][free_sum]) : 0));
				}
			}
		}
	}
	int ans = 0;
	for (int I = 0; I < 3; ++I)
	for (int v = 0; v < 4; ++v)
		ans = max(ans, answer[I][v][(p.first - p.second) / 2][(p.first + p.second) / 2]);
	cout << ans << '\n';
	return 0;
}