from datetime import datetime
import itertools


def is_valid(date_text):
    try:
        datetime.strptime(date_text, '%Y %m %d')
        return True
    except ValueError:
        return False


year, month, day = input().split()
chars = list(year + month + day)
permutations = itertools.permutations(chars)

ans = []
for p in permutations:
    cur = ''.join(p[4:]) + ' ' + p[0] + p[1] + ' ' + p[2] + p[3]
    if is_valid(cur):
        ans.append(cur)

ans = set(ans)
print(len(ans))
print('\n'.join(sorted(ans)))
