#include "testlib.h"

const int MAXN = 1e5;
const int MAXV = 1e9;

int main(int argc, char* argv[])
{
  registerValidation(argc, argv);
  int n = inf.readInt(1, MAXN, "n");
  inf.readEoln();
  std::set<int> numbers;
  for (int i = 0; i < n; i++) {
    int x = inf.readInt(0, MAXV, ("a[" + std::to_string(i + 1) + "]").c_str());
    numbers.insert(x);
    if (i + 1 < n) {
      inf.readSpace();
    } else {
      inf.readEoln();
    }
  }
  if ((int)numbers.size() != n) {
    quitf(_fail, "Number in array `a` are not unique");
  }
  int q = inf.readInt(1, MAXN, "q");
  inf.readEoln();
  for (int i = 0; i < q; i++) {
    inf.readInt(0, MAXV, ("b[" + std::to_string(i + 1) + "]").c_str());
    if (i + 1 < q) {
      inf.readSpace();
    } else {
      inf.readEoln();
    }
  }
  inf.readEof();
  return 0;
}
