#include <bits/stdc++.h>

const int BITS_COUNT = 30;

int main() {
    int n;
    std::cin >> n;
    assert(n <= 10);
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    int allAnd = a[0];
    for (int i = 1; i < n; i++) {
        allAnd &= a[i];
    }
    std::vector<bool> can(1 << n, false);
    for (int mask = 1; mask < (1 << n); mask++) {
        int canv = -1;
        for (int i = 0; i < n; i++) {
            if ((mask & (1 << i)) > 0) {
                canv = (canv == -1) ? a[i] : (a[i] & canv);
            }
        }
        can[canv] = true;
    }
    int q;
    std::cin >> q;
    std::vector<std::vector<bool>> dp(1 << n, std::vector<bool>(1 << n, false));
    std::vector<int> masks;
    for (int i = 0; i < (1 << n); i++) {
        if (can[i]) {
            dp[0][i] = true;
            masks.push_back(i);
        }
    }
    for (int i = 0; i + 1 < (1 << n); i++) {
        for (int j = 0; j < (1 << n); j++) {
            if (!dp[i][j]) continue;
            dp[i + 1][j] = true;
            for (int x : masks)
                dp[i + 1][x | j] = true;
        }
    }
    for (int i = 0; i < q; i++) {
        int x;
        std::cin >> x;
        if (x == 0) {
            puts(allAnd == 0 ? "YES" : "NO");
            continue;
        }
        puts(dp[(1 << n) - 1][x] ? "YES" : "NO");
    }
    return 0;
}
