#include "testlib.h"
#include <string>
using namespace std;

const int MAXN = 1e5;
const int MAXX = 1e9;
const int MAXA = 100;

int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    for (int i = 0; i < n; i++)
    {
        inf.readInt(1, MAXA, "a_" + to_string(i + 1));
        if (i < n - 1)
            inf.readSpace();
        else 
            inf.readEoln();
    }
    int prev = 0;
    for (int i = 0; i < n; i++)
    {
        int x = inf.readInt(1, MAXX, "x_" + to_string(i + 1));
        ensuref(x >= prev, "x_%d < x_%d", i, i - 1);
        prev = x;
        if (i < n - 1)
            inf.readSpace();
        else 
            inf.readEoln();
    }
    inf.readEof();
    return 0;
}