/**
 *    author:  [itmo] enot110
 *    created: 06.02.2018 07:43:44       
**/
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 1e5 + 10;

int a[N][3];

int f(int x, int y)
{
    int val = 0;
    forn(i, 3) val += a[x][i] < a[y][i];
    return val >= 2;
}

int p[N];

int main()
{
    #ifdef HOME
        assert(freopen("1.in", "r", stdin));
        assert(freopen("1.out3", "w", stdout));
    #endif
    int n;
    scanf("%d", &n);
    forn(i, 3) forn(j, n)
    {
        int x;
        scanf("%d", &x);
        a[x - 1][i] = j;
    }
    forn(i, n) p[i] = i;
    sort(p, p + n, [&](int i, int j) {
        return a[i][0] + a[i][1] + a[i][2] < a[j][0] + a[j][1] + a[j][2];
    });

    int res = -1;
    forn(ii, n)
    {
        int i = p[ii];
        res = i;
        forn(j, n) if (j != i && !f(res, j))
        {
            res = -1;
            break;
        }
        if (res != -1)
        {
            eprintf("ii = %d from %d\n", ii, n);
            break;
        }
    }
    if (res >= 0) res++;
    printf("%d\n", res);

    #ifdef HOME
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
