#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

const int SZ = 1e5;
int from[SZ * 2];
int q[SZ * 2];
bool is_good[SZ];
int cnt_bits[SZ];
int arr_log[SZ];

bool solve(int n, int m, int k, vector<pii> const& edges) {
	vector<int> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		tie(a, b) = edges[i];
		graph[a] |= 1 << b;
		graph[b] |= 1 << a;
	}

	for (int i = 0; i < n; ++i) {
		arr_log[1 << i] = i;
	}

	is_good[0] = 1;
	cnt_bits[0] = 0;
	for (int i = 1; i < 1 << n; ++i) {
		int any = i & (-i);
		cnt_bits[i] = cnt_bits[i ^ any] + 1;
		is_good[i] = is_good[i ^ any] && !((i ^ any) & graph[arr_log[any]]);
	}

	int l = 0, r = 0;
	q[r++] = 0;
	fill(from, from + SZ, -1);
	from[0] = 0;
	int mask = (1 << n) - 1;
	while (l < r) {
		int cur = q[l++];
		int st = cur;
		//cerr << st << endl;
		int where = cur & 1;
		cur >>= 1;
		if (!where) {
			cur = (~cur) & mask;
		}

		for (int move = cur; ; move = (move - 1) & cur) {
			//cerr << move << " " << cnt_bits[move] << " " << is_good[cur ^ move] << endl;
			if (cnt_bits[move] <= k && is_good[cur ^ move]) {
				int to = cur ^ move;
				if (!where) {
					to = (~to) & mask;
				}
				to = (to << 1) | (1 - where);
				if (from[to] == -1) {
					from[to] = st;
					q[r++] = to;
				}
			}

			if (move == 0) {
				break;
			}
		}
	}

	if (from[(mask << 1) | 1] == -1) {
		return false;
	}

	return true;
}


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, m;
	cin >> n >> m;
	vector<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		edges.push_back({a, b});
	}

	for (int i = 1; ; ++i) {
		if (solve(n, m, i, edges)) {
			cout << n << " " << m << " " << i << "\n";
			for (auto e : edges) {
				cout << e.ff + 1 << " " << e.ss + 1 << "\n";
			}
			return 0;
		}
	}

	return 0;
}