#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n, m, k;
	cin >> n >> m >> k;
	vector<int> order(n);
	iota(order.begin(), order.end(), 0);
	shuffle(order.begin(), order.end());

	vector<pii> edges;

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		edges.push_back({order[a], order[b]});
	}

	shuffle(edges.begin(), edges.end());

	cout << n << " " << m << " " << k << "\n";
	for (pii e : edges) {
		if (rnd.next(0, 1)) {
			swap(e.ff, e.ss);
		}
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}

	return 0;
}