#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	int n = inf.readInt(1, 15, "n");
	inf.readSpace();
	int m = inf.readInt(0, n * (n - 1) / 2, "m");
	inf.readSpace();
	int k = inf.readInt(1, 15, "k");
	inf.readEoln();

	set<pii> edges;
	for (int i = 0; i < m; ++i) {
		int a = inf.readInt(1, n, "a") - 1;
		inf.readSpace();
		int b = inf.readInt(1, n, "b") - 1;
		inf.readEoln();
		ensuref(a != b, "there should be no loops");

		if (a > b) {
			swap(a, b);
		}
		
		ensuref(!edges.count({a, b}), "all pairs should be distinct");
		edges.insert({a, b});
	}

	inf.readEof();

	return 0;
}