#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int SZ = 1e5;
int from[SZ * 2];
int q[SZ * 2];
bool is_good[SZ];
int cnt_bits[SZ];
int arr_log[SZ];
int mask;
int n, m, k;

int dfs(int cur) {
	int st = cur;
	//cerr << st << endl;
	int where = cur & 1;
	cur >>= 1;
	if (!where) {
		cur = (~cur) & mask;
	}

	vector<int> arr;
	for (int move = cur; ; move = (move - 1) & cur) {
		arr.push_back(move);
		if (move == 0) {
			break;
		}
	}
	shuffle(arr.begin(), arr.end(), tw);
	for (int move : arr) {
		//cerr << move << " " << cnt_bits[move] << " " << is_good[cur ^ move] << endl;
		if (cnt_bits[move] <= k && is_good[cur ^ move]) {
			int to = cur ^ move;
			if (!where) {
				to = (~to) & mask;
			}
			to = (to << 1) | (1 - where);
			if (from[to] == -1) {
				from[to] = st;
				dfs(to);
			}
		}
	}
	return 0;
}

void solve() {
	cin >> n >> m >> k;
	vector<int> graph(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		graph[a] |= 1 << b;
		graph[b] |= 1 << a;
	}

	for (int i = 0; i < n; ++i) {
		arr_log[1 << i] = i;
	}

	is_good[0] = 1;
	cnt_bits[0] = 0;
	for (int i = 1; i < 1 << n; ++i) {
		int any = i & (-i);
		cnt_bits[i] = cnt_bits[i ^ any] + 1;
		is_good[i] = is_good[i ^ any] && !((i ^ any) & graph[arr_log[any]]);
	}

	fill(from, from + SZ, -1);
	from[0] = 0;
	mask = (1 << n) - 1;
	dfs(0);
	
	
	if (from[(mask << 1) | 1] == -1) {
		cout << "-1\n";
		return;
	}

	int cur = (mask << 1) | 1;
	vector<int> ans;
	while (cur != 0) {
		int tmp = from[cur];
		int moved = (tmp >> 1) ^ (cur >> 1);
		ans.push_back(moved);
		cur = tmp;
	}

	reverse(ans.begin(), ans.end());
	assert(szof(ans) % 2 == 1);
	cout << szof(ans) << "\n";
	for (int num : ans) {
		vector<int> tmp;
		for (int i = 0; i < n; ++i) {
			if (num & (1 << i)) {
				tmp.push_back(i);
			}
		}
		shuffle(tmp.begin(), tmp.end(), tw);
		cout << szof(tmp) << " ";
		for (int ind : tmp) {
			cout << ind + 1 << " ";
		}
		cout << "\n";
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}