#include <iostream>

using namespace std;

long long getIntegerByNum(long long n) {
	long long answer = 0;
    long long base = 1;
	while (n > 0) {
		answer = answer + (n % 9) * base;
		base *= 10;
		n /= 9;										    
	}
	return answer;
}

long long getNumByInteger(long long value) {
	long long le = 0LL;
	long long ri = (long long)1e15;
	while (ri - le > 1) {
		long long mid = (le + ri) / 2LL;
		if (getIntegerByNum(mid) <= value) {
			le = mid;
		} else {
			ri = mid;
		}
	}
	return le;
}


int main() {
	long long l, r;
	cin >> l >> r;
	cout << getNumByInteger(r) - getNumByInteger(l - 1) << endl;
	return 0;
}

