#include <iostream>
#include <vector>

using namespace std;

long long calc(long long n) {
	long long answer = 0LL;
	long long pw = 1LL;
	while (n > 0LL) {
		long long digit = n % 10LL;
		answer += (digit * pw);
		pw *= 9LL;
		n /= 10LL;
	}
	return answer;
}

int main() {
	long long l, r;
	cin >> l >> r;
	cout << calc(r) - calc(l) + 1 << endl;
	return 0;
}
