#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXH = 1e6;
const int MAXR = 1e6;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(int h, int r) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << h << endl << r << endl;
}


int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    write_test(2, 1);
    for (int i = 1; i <= 3; i++)
        for (int j = 11; j <= 13; j++)
            write_test(2 * i, j);
    for (int i = 0; i < 5; i++)
        write_test(2 * rnd.next(3) + 2, rnd.next(MAXR / 2, MAXR));
    for (int i = 0; i < 5; i++)
        write_test(2 * rnd.next(MAXH / 4) + 2, rnd.next(MAXR / 2, MAXR));
    for (int i = 0; i < 5; i++)
        write_test(2 * rnd.next(MAXH / 4, MAXH / 2), rnd.next(MAXR / 2, MAXR));
    write_test(MAXH, MAXR);
    return 0;
}