#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int max_h = 250000, max_w = 250000, max_n = 250000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	int h = inf.readInt(1, max_h, "h");
	inf.readSpace();
	int w = inf.readInt(1, max_w, "w");
	inf.readSpace();
	int n = inf.readInt(1, max_n, "n");
	inf.readEoln();
	map<pair<int, int>, int> c;
	for (int i = 0; i <= n; ++i)
	{
		int y, x;
		if (i)
		{
			char buffer[33];
			itoa(i, buffer, 10);
			y = inf.readInt(1, h, (string() + "r_{" + buffer + "}").c_str());
			inf.readSpace();
			x = inf.readInt(1, w, (string() + "q_{" + buffer + "}").c_str());
			ensuref(((x ^ y) & 1) == 0, "%d%s black checker in %d%s row and %d%s column is on a white cell",
					i, englishEnding(i).c_str(),
					y, englishEnding(y).c_str(),
					x, englishEnding(x).c_str());
		}
		else
		{
			y = inf.readInt(1, h, "p");
			inf.readSpace();
			x = inf.readInt(1, w, "q");
			ensuref(((x ^ y) & 1) == 0, "white checker in %d%s row and %d%s column is on a white cell",
					y, englishEnding(y).c_str(),
					x, englishEnding(x).c_str());
		}
		inf.readEoln();
		pair<int, int> p(y, x);
		auto t = c.find(p);
		if (t != c.end())
		{
			int r = t -> second;
			if (r)
			{
				ensuref(false, "%d%s and %d%s black checkers are both in %d%s row and %d%s column",
					r, englishEnding(r).c_str(),
					i, englishEnding(i).c_str(),
					y, englishEnding(y).c_str(),
					x, englishEnding(x).c_str());
			}
			else
			{
				ensuref(false, "white checker and %d%s black checker are both in %d%s row and %d%s column",
					i, englishEnding(i).c_str(),
					y, englishEnding(y).c_str(),
					x, englishEnding(x).c_str());
			}
		}
		c[p] = i;
	}
	inf.readEof()
;}
