#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
const int MAXS = 100000, MAXQ = 15000;
const ll MAXL = 1000000000000000;
const ll MAXK = 1000000000000000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	string s = inf.readToken("[0-3]+");
	ensuref(szof(s) <= MAXS, "initial string should be no longer than %d symbols", MAXS);
	inf.readEoln();
	ll l = szof(s);
	int tot_len = 0;

	int q = inf.readInt(0, MAXQ, "q");
	inf.readEoln();

	for (int i = 0; i < q; ++i) {
		int t = inf.readInt(1, 4, "t");
		inf.readSpace();
		// 1 -- insert pos w
		// 2 -- erase pos l
		// 3 -- reverse pos l
		// 4 -- clone pos l k
		if (t == 1) {
			ll pos = inf.readLong(0, l, "pos");
			inf.readSpace();
			string w = inf.readToken("[0-3]+");
			inf.readEoln();

			tot_len += szof(w);
			ensuref(l + szof(w) <= MAXL, "string should be no longer than %lld symbols", MAXL);
			l += szof(w);
		} else if (t == 2) {
			ll pos = inf.readLong(0, l - 1, "pos");
			inf.readSpace();
			ll len = inf.readLong(1, l - pos, "len");
			inf.readEoln();
			l -= len;
			ensuref(l > 0, "string should be not empty");
		} else if (t == 3) {
			ll pos = inf.readLong(0, l - 1, "pos");
			inf.readSpace();
			ll len = inf.readLong(1, l - pos, "len");
			inf.readEoln();
		} else {
			ll pos = inf.readLong(0, l - 1, "pos");
			inf.readSpace();	
			ll len = inf.readLong(1, l - pos, "len");
			inf.readSpace();
			ll k = inf.readLong(1, MAXK, "k");
			inf.readEoln();
			ensuref(l + (double) len * k <= 4 * MAXL && l + len * k <= MAXL, "string should be no longer than %lld symbols", MAXL);
			l += len * k;
		}
	}

	ensuref(tot_len <= MAXS, "sum of lengths of inserting strings should be no more than %d symbols", MAXS);

	inf.readEof();

	return 0;
}