#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int SZ = 4;

int get_ans(string const& s) {
	vector<int> d(SZ);
	for (char c : s) {
		for (int i = c - '0'; i >= 0; --i) {
			d[c - '0'] = max(d[c - '0'], d[i] + 1);
		}
	}
	return *max_element(d.begin(), d.end());
}

void solve() {
	string s;
	cin >> s;
	cout << get_ans(s) << "\n";
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int t;
		cin >> t;
		// 1 -- insert pos w
		// 2 -- erase pos l
		// 3 -- reverse pos l
		// 4 -- clone pos l k
		if (t == 1) {
			int pos;
			string w;
			cin >> pos >> w;
			s = s.substr(0, pos) + w + s.substr(pos);
		} else if (t == 2) {
			int pos, l;
			cin >> pos >> l;
			s = s.substr(0, pos) + s.substr(pos + l);
		} else if (t == 3) {
			int pos, l;
			cin >> pos >> l;
			reverse(s.begin() + pos, s.begin() + pos + l);
		} else {
			int pos, l, k;
			cin >> pos >> l >> k;
			string w = s.substr(pos, l);
			string res = s.substr(0, pos + l);
			for (int j = 0; j < k; ++j) {
				res += w;
			}
			res += s.substr(pos + l);
			swap(res, s);
		}
		//cerr << s << endl;
		cout << get_ans(s) << "\n";
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}