#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    string s = inf.readToken();
    if (s.empty() || s.size() > 100000) {
        inf.quitf(_fail, "invalid string size");
    }
    for (char c : s) {
        if (!('a' <= c && c <= 'z')) inf.quitf(_fail, "invalid character");
    }
    inf.readEoln();
    inf.readInt(0, 100000, "l");
    inf.readSpace();
    inf.readInt(0, 100000, "r");
    inf.readSpace();
    inf.readInt(0, 100000, "k");
    inf.readEoln();
    inf.readEof();
}