#include <bits/stdc++.h>
#include "testlib.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	assert(argc >= 4);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int k = atoi(argv[3]);

	cout << n << " " << m << " " << k << "\n";

	set<pii> edges;

	for (int i = 0; i < m; ++i) {
		while (true) {
			int a = rnd.next(0, n - 1);
			int b = rnd.next(0, n - 1);
			if (a == b) {
				continue;
			}
			if (a > b) {
				swap(a, b);
			}
			if (edges.count({a, b})) {
				continue;
			}
			edges.insert({a, b});
			break;
		}
	}

	for (pii e : edges) {
		cout << e.ff + 1 << " " << e.ss + 1 << "\n";
	}

	return 0;
}