#include "testlib.h"
using namespace std;

const long long MAX_VALUE = (long long)1e15;

void check(long long n)
{
    stringstream ss;
	ss << n;
	string s;
	ss >> s;
	for (char c : s)
	    ensuref(c != '9', "%s contain 9", s.c_str());
}

int main(int argc, char * argv[]) {
    registerValidation(argc, argv);
    long long l = inf.readLong(1, MAX_VALUE, "l");
	inf.readSpace();
	long long r = inf.readLong(l, MAX_VALUE, "r");
	inf.readEoln();
	inf.readEof();
	check(l);
	check(r);
	return 0;
}
